;; Problem 24
;; 16 August 2002
;;
;; A permutation is an ordered arrangement of objects. For example,
;; 3124 is one possible permutation of the digits 1, 2, 3 and 4. If
;; all of the permutations are listed numerically or alphabetically,
;; we call it lexicographic order. The lexicographic permutations of
;; 0, 1 and 2 are:
;;
;; 012   021   102   120   201   210
;;
;; What is the millionth lexicographic permutation of the digits 0, 1, 2, 3, 4, 5, 6, 7, 8 and 9?


(defun curry (fn &rest outer-args)
  (lambda (&rest args)
    (apply fn (append outer-args args))))

(defun rcurry (fn &rest outer-args)
  (lambda (&rest args)
    (apply fn (append args outer-args))))

;; (let ((test (curry #'equalp "a")))
;;   (format t "a:~a~&" (funcall test "a"))
;;   (format t "b:~a~&" (funcall test "b")))

(defun flatten (tree)
  (labels ((inner-flatten (acc tree)
	     (format t "inner-flatten, acc:~a tree:~a~&" acc tree)
	     (cond ((null tree)
		    acc)
		   ((listp (first tree))
 		    (inner-flatten
 		     (inner-flatten acc (first tree))
 		     (rest tree)))
		   (t
		    (inner-flatten
		     (cons (first tree) acc)
		     (rest tree))))))
    (reverse (inner-flatten (list) tree))))

; (flatten '(1 ((2 3) 4)))

(defun all-permutations (items)
  (cond ((= 1 (length items))
	 (list items))
	(t
	 (let ((result (list)))
	   (loop for item in items
		 do
		 (let ((remainder (remove-if (curry #'equalp item) items)))
		   (loop for perm in (all-permutations remainder)
			 do
			 (push (cons item perm) result))))
	   result))))

(defun list->vector (lst)
  (let ((result (make-array (length lst) :adjustable t :fill-pointer 0)))
    (loop for item in lst
	  do
	  (vector-push-extend item result))
    result))

;(list->vector '(1 2)) 

(defun vector-remove-if (pred vec)
  (let ((result (list)))
    (loop for item across vec
	  do
	  (if (not (funcall pred item))
	      (push item result)))
    (list->vector (reverse result))))

; (vector-remove-if #'(lambda (x) (= x 1)) #(1 2 3))

;; (defun vector-all-permutations (items)
;;   (cond ((= 1 (length items))
;; 	 (format t "len was 1, returning items:~a => :'~a'~&"
;; 		 items
;; 		 (list->vector (list items)))
;; 	 (list->vector (list items)))
;; 	(t
;; 	 (let ((result (make-array (length items) :adjustable t :fill-pointer 0)))
;; 	   (loop for item across items
;; 		 do
;; 		 (format t "items:~a item:~a~&" items item)
;; 		 (let ((remainder (vector-remove-if (curry #'equalp item) items)))
;; 		   (loop for perm across (vector-all-permutations remainder)
;; 			 do
;; 			 (format t "perm:~a~&" perm)
;; 			 (format t "")
;; 			 (vector-push-extend (vector-push-extend item perm) result))))
;; 	   result))))

;; (vector-all-permutations #(1 2))

(format t "building all-perms...~&")

(defun num-list->string (nlist)
  (let ((str ""))
    (loop for num in nlist
	  do
	  (setf str (concatenate 'string str (format nil "~d" num))))
    str))


(defun list> (left right)
  (cond ((or (null left)
	     (null right))
	 nil)
	((= (first left)
	    (first right))
	 (list> (rest left)
		   (rest right)))
	((> (first left)
	    (first right))
	 t)
	(t
	 nil)))

(defun list< (left right)
  (cond ((or (null left)
	     (null right))
	 nil)
	((= (first left)
	    (first right))
	 (list> (rest left)
		   (rest right)))
	((> (first left)
	    (first right))
	 nil)
	(t
	 t)))

; (list< '(1 3 1) '(9 1 1))

(defvar *all-perms* (sort 
		     (all-permutations '(0 1 2 3 4 5 6 7 8 9))
		     #'list<))

;(first *all-perms*)
;(second *all-perms*)

; (setf *all-perms* (mapcar #'num-list->string (all-permutations '(0 1 2 3 4 5 6 7 8 9))))
	  

(format t "all-perms:~a~&" (length *all-perms*))


;(num-list->string '(1 2 3))

;; this exhausts sbcl's heap
;; (format t "building string-perms~&")
;; (defvar *string-perms*
;;   (mapcar #'num-list->string *all-perms*))
;; (format t "string-perms:~a~&" (length *string-perms*))

'(loop for perm in *sorted-perms*
      for ii from 1 upto 1000000
      finally (return perm))

	